*
* Reading about: Fish
*
* (c) 1988, Orange Cherry
* (u) 2021, Antoine Vignau
*

         mx	%00
         rel
	 dsk	MAING
         lst	off

*------------------------

GSOS     EQU   $E100A8

	use   4/ACE.Macs
	use   4/Ctl.Macs
	use   4/Dialog.Macs
	use   4/Desk.Macs
	use   4/Event.Macs
	use   4/Font.Macs
	use   4/Int.Macs
	use   4/Line.Macs
	use   4/List.Macs
	use   4/Locator.Macs
	use   4/Mem.Macs
	use   4/Menu.Macs
	use   4/Misc.Macs
	use   4/Print.Macs
	use   4/QD.Macs
	use   4/QDAux.Macs
	use   4/SANE.Macs
	use   4/Scrap.Macs
	use   4/Sound.Macs
	use   4/Std.Macs
	use   4/Text.Macs
	use   4/Util.Macs
	use   4/Window.Macs

*------------------------

         CLC
         XCE
         REP   #$30
         PHK
         PLB
         _TLStartUp
         PEA   $0000
         _MMStartUp
         JSR   L010119
         PLA
         STA   L01012A
         _MTStartUp
         PEA   $0000
         PEA   $0000
         PEA   $0000
         PEA   $0300
         LDA   L01012A
         PHA
         PEA   $C005
         PEA   $0000
         PEA   $0000
         _NewHandle
         JSR   L010119
         PLA
         STA   $00
         PLA
         STA   $02
         LDA   [$00]
         STA   L01012C
         LDA   #$0300
         JSR   L0102E8
         PHA
         PEA   $0000
         PEA   $0000
         LDA   L01012A
         PHA
         _QDStartUp
         JSR   L010119
         _PenNormal
         PEA   $0000
         _SetFontFlags
         PEA   $0004
         _SetTextMode
         PEA   $0009
         _SetForeColor
         JSR   L010198
         LDA   #$0032
         STA   L010179
         LDA   #$0064
         STA   L01017B
         LDA   #$001E
         STA   L01017D
         LDA   #$0122
         STA   L01017F
         JSR   L01022D
         LDA   #$0050
         STA   L010185
         PEA   $0000
         PEA   ^L01012E
         PEA   L01012E
         _StringWidth
         PLA
         JSR   L0102D6
         JSR   L0101A7
         LDA   L010181
         PHA
         LDA   L010185
         PHA
         _MoveTo
         PEA   ^L01012E
         PEA   L01012E
         _DrawString
         LDA   #$004E
         STA   L010185
         DEC   L010181
         DEC   L010181
         JSR   L0101B2
         LDA   L010181
         PHA
         LDA   L010185
         PHA
         _MoveTo
         PEA   ^L01012E
         PEA   L01012E
         _DrawString
         JSR   L010190
	 
* AV 202103 - Replace the STP opcode!!

*         STP              ; AARRGGHHHh

	ldx	#15	; courte attente
	jsr	L0101A0

*         _EMShutDown
*         _SoundShutDown
         _QDShutDown
         _MTShutDown
         LDA   L01012A
         PHA
         _DisposeAll
         JSR   L010119
         LDA   L01012A
         PHA
         _MMShutDown
         _TLShutDown
         JSL   GSOS
         DW    $0029      ; Quit
         ADRL  L011463
L011463  ADRL  $00000000  ;  path name
         DW    $0000      ;  flags

*--- end of replacement

L010119  BCS   L01011C
         RTS

L01011C  PHA
         PEA   $0000
         PEA   $0000
         _SysFailMgr
L01012A  DW    $0000
L01012C  DW    $0000
L01012E  STR   'Thank you for using our program.'
L01014F  DB    $00
         DB    $00
         DB    $01
         DB    $00
         DB    $02
         DB    $00
         DB    $03
         DB    $00
         DB    $04
         DB    $00
         DB    $05
         DB    $00
         DB    $06
         DB    $00
         DB    $07
         DB    $00
         DB    $0A
         DB    $04
         DB    $FF
         DB    $0F
         DB    $1B
         DB    $05
         DB    $2C
         DB    $06
         DB    $3D
         DB    $07
         DB    $4F
         DB    $08
         DB    $5F
         DB    $09
         DB    $6F
         DB    $0A
L01016F  DB    $00
         DB    $00
         DB    $00
         DB    $00
         DB    $00
         DB    $00
         DB    $00
         DB    $00
L010177  DB    $00
         DB    $00
L010179  DB    $00
         DB    $00
L01017B  DB    $00
         DB    $00
L01017D  DB    $00
         DB    $00
L01017F  DB    $00
         DB    $00
L010181  DB    $00
         DB    $00
L010183  DB    $00
         DB    $00
L010185  DB    $00
         DB    $00
L010187  DB    $00
         DB    $00

L010189  LDA   #$3000
L01018C  DEC
         BNE   L01018C
         RTS

L010190  _GrafOn
         RTS

L010198  _GrafOff
         RTS

L0101A0  JSR   L010189
         DEX
         BNE   L0101A0
         RTS

L0101A7  PEA   $0007
         _SetForeColor
         RTS

L0101B2  PEA   $0009
         _SetForeColor
         RTS

L0101BD  LDA   #$000E
         STA   L010187
         LDA   L01017D
         CLC
         ADC   #$0004
         STA   L010181
         LDA   L01017F
         CLC
         SBC   #$0004
         STA   L010183
         LDA   L010179
         CLC
         ADC   #$0004
         STA   L010185
         JMP   L0101E4

L0101E4  LDA   L010187
         PHA
         _SetSolidPenPat
         _HidePen
         LDA   L010181
         PHA
         LDA   L010185
         PHA
         _MoveTo
         _ShowPen
         LDA   L010183
         PHA
         LDA   L010185
         PHA
         _LineTo
         INC   L010185
         DEC   L010187
         LDA   L010187
         CMP   #$0009
         BEQ   L01022C
         JMP   L0101E4
L01022C  RTS

L01022D  LDX   L010179
L010230  LDA   #$0001
         STAL  $E19D00,X
         INX
         TXA
         CMP   L01017B
         BNE   L010230
         PEA   $0001
         LDA   #^L01014F
         PHA
         LDA   #L01014F
         PHA
         _SetColorTable
         LDA   #^L01016F
         PHA
         LDA   #L01016F
         PHA
         LDA   L01017D
         PHA
         LDA   L010179
         PHA
         LDA   L01017F
         PHA
         LDA   L01017B
         PHA
         _SetRect
         _PenNormal
         LDA   #$0004
         STA   L010177
L01027C  LDA   L010177
         PHA
         _SetSolidPenPat
         LDA   #^L01016F
         PHA
         LDA   #L01016F
         PHA
         _FrameRect
         LDA   #^L01016F
         PHA
         LDA   #L01016F
         PHA
         PEA   $0001
         PEA   $0001
         _InsetRect
         INC   L010177
         LDA   L010177
         CMP   #$0008
         BEQ   L0102B9
         JMP   L01027C

L0102B9  PEA   $0008
         _SetSolidPenPat
         LDA   #^L01016F
         PHA
         LDA   #L01016F
         PHA
         _PaintRect
         JSR   L0101BD
         RTS

L0102D6  LSR
         STA   L010181
         LDA   #$00A0
         SEC
         SBC   L010181
         STA   L010181
         RTS

         LDA   #$0100
L0102E8  CLC
         LDY   L01012C
         ADC   L01012C
         STA   L01012C
         TYA
         RTS

